%% Calculate average amplitude change
% EMGaac(X,samples,scale,file)
% X:        Matrix containing the data,currenly assumed to contain 8 rows
%           of data. One for each electrode.
% samples:  # samples with new frequency.
% scale:    # times to scale down the signal.
% 
% AAC = (1/N)*Sum( |x_i+1 - x_i|)
%    
% Per Ferdinand Bach, perferdi@stud.ntnu.no
% $Revision: 1.5 $Date: 2009/01/21 13:00:00 $

function AAC = EMGaac(X,samples,scale)
    for k=1:samples
        for t=1:8;
            i = (k-1)*scale+1;
            i1 = i+1;
            N =(k*scale)-1; 
            Xaac = X(t,i:N);
            Xaac1 = X(t,i1:N+1); %x_i+1
            AAC(t,k) = (1/(N-i))*sum(abs(Xaac1-Xaac));
        end
    end