%% Calculate AR coefficients
% EMGar(X,samples,scale,file)
% X:        Matrix containing the data,currenly assumed to contain 8 rows
%           of data. One for each electrode.
% samples:  # samples with new frequency.
% scale:    # times to scale down the signal.
% 
% Using model order p=4 to find the coefficients.
% Returns the coefficients, currently 3.
%
% function myLevinson.m used.
%
% Per Ferdinand Bach, perferdi@stud.ntnu.no
% $Revision: 1.7 $Date: 2009/03/12 16:00:00 $

function AR = EMGar(X,samples,scale)
    p = 4;
    AR = zeros([8,length(samples),(p-1)],'double');
    tic
    for k=1:samples
        i = (k-1)*scale+1;
        N =(k*scale)-1;
        for t=1:8;
            [Xar,msep,K] = myLevinson(X(t,i:N),p);
            for j=1:p-1
                AR(t,k,j) = abs(Xar(j));
            end
        end
    end
    toc