%% Calculate cepstral coefficients
% EMGcc(X,samples,scale,file)
% X:        Matrix containing the data,currenly assumed to contain 8 rows
%           of data. One for each electrode.
% samples:  # samples with new frequency.
% scale:    # times to scale down the signal.
% 
% CC = sum(rceps(X));
%
% Per Ferdinand Bach, perferdi@stud.ntnu.no
% $Revision: 1.5 $Date: 2009/01/21 13:00:00 $

function CC = EMGcc(X,samples,scale) 
    for k=1:samples
        for t=1:8;
            i = (k-1)*scale+1;
            Xcc = rceps(X(t,i));
            CC(t,k) = sum(Xcc);
        end
    end