%% Find energy of wavelet coefficients
% EMGewc(X,samples,scale)
% X:        Matrix containing the data,currenly assumed to contain 8 rows
%           of data. One for each electrode.
% samples:  # samples with new frequency.
% scale:    # times to scale down the signal.
% 
%
% Per Ferdinand Bach, perferdi@stud.ntnu.no
% $Revision: 1.5 $Date: 2009/03/12 16:00:00 $

function EWC = EMGewc(X,samples,scale) 
    global wname nMax;
    EWC = zeros([8,length(samples),nMax],'double');
    for k=1:samples
        i = (k-1)*scale+1;
        N =(k*scale);
        for t=1:8;
            [C,L] = wavedec(X(t,i:N),nMax,wname);
            [Ea,Ed] = wenergy(C,L);
            for h=1:length(Ed)
               EWC(t,k,h) = Ed(h);
            end
        end
    end