%% Find energy of wavelet coefficients
% EMGwt(X,samples,scale)
% X:        Matrix containing the data,currenly assumed to contain 8 rows
%           of data. One for each electrode.
% samples:  # samples with new frequency.
% scale:    # times to scale down the signal.
% 
%
% Per Ferdinand Bach, perferdi@stud.ntnu.no
% $Revision: 1.0 $Date: 2009/02/21 13:00:00 $

function EWCL = EMGewcl(X,samples,scale) 
    global wname nMax;
    EWCL = zeros([8,length(samples)],'double');
    tic
    for k=1:samples
        i = (k-1)*scale+1;
        N =(k*scale);
        for t=1:8;
            [C,L] = wavedec(X(t,i:N),nMax,wname);
            [Ea,Ed] = wenergy(C,L);
            EWCL(t,k,1) = Ea;
        end
    end
    toc