%% Find energy of wavelet coefficients
% EMGewpc(X,samples,scale)
% X:        Matrix containing the data,currenly assumed to contain 8 rows
%           of data. One for each electrode.
% samples:  # samples with new frequency.
% scale:    # times to scale down the signal.
% 
%
% Per Ferdinand Bach, perferdi@stud.ntnu.no
% $Revision: 1.7 $Date: 2009/03/27 16:00:00 $

function EWPC = EMGewpc(X,samples,scale) 
    global wname nMax;
    EWPC = zeros([8,length(samples),nMax],'double');
    for k=1:samples
        i = (k-1)*scale+1;
        N =(k*scale);
        for t=1:8;
            [T] = wpdec(X(t,i:N),nMax,wname);
            [E] = wenergy(T);
            for h=2:length(E)
                EWPC(t,k,(h-1)) = E(h);
            end
        end
    end