%% Calculate histogram
% EMGhist(X,samples,scale,file)
% X:        Matrix containing the data,currenly assumed to contain 8 rows
%           of data. One for each electrode.
% samples:  # samples with new frequency.
% scale:    # times to scale down the signal.
% 
% Returns the buckets.
%
% HIST = internal Matlab command.
%
% Per Ferdinand Bach, perferdi@stud.ntnu.no
% $Revision: 1.7 $Date: 2009/03/12 16:00:00 $

function HIST = EMGhist(X,samples,scale)
    global numHistBins
    
    HIST = zeros([8,length(samples),numHistBins],'double');
    for k=1:samples
        for t=1:8;
            i = (k-1)*scale+1;
            N =(k*scale)-1;
            Xext = X(t,i:N);
            Xhist = hist(Xext,numHistBins);
            for j=1:numHistBins
                HIST(t,k,j) = abs(Xhist(j));
            end
        end
    end