%% Calculate myopulse percentage rate
% EMGmyop(X,samples,scale,file)
% X:        Matrix containing the data,
%           currenly assumed to contain 8 rows
%           of data. One for each electrode.
% samples:  # samples with new frequency.
% scale:    # times to scale down the signal.
% 
% MYOP = (1/N)*Sum f(x_i)
% threshold = 50mjuV?.
% Threshold depends on the gain of the electrode etc.
%
% Per Ferdinand Bach, perferdi@stud.ntnu.no
% $Revision: 1.5 $Date: 2009/01/21 13:00:00 $

function MYOP = EMGmyop(X,samples,scale) 
    thresh = 0.9; %0.15 %50e-06;
    for k=1:samples
        for t=1:8;
            i = (k-1)*scale+1;
            N =(k*scale);
            Xa = abs(X(t,i:N));
            Xmyop = length(find(Xa>thresh));
            MYOP(t,k) = (1/(N-i))*sum(Xmyop)*100;
        end
    end