%% Calculate number of turns
% EMGnt(X,samples,scale,file)
% X:        Matrix containing the data,currenly 
%           assumed to contain 8 rows
%           of data. One for each electrode.
% samples:  # samples with new frequency.
% scale:    # times to scale down the signal.
% 
% NT = Sum(sgn(x_i-x_i+1)(x_i+2-x_i+1))
%
% Per Ferdinand Bach, perferdi@stud.ntnu.no
% $Revision: 1.5 $Date: 2009/02/05 17:00:00 $

function NT = EMGnt(X,samples,scale) 
    for k=1:samples
        for t=1:8;
            i = (k-1)*scale+1;
            i1 = i+1;
            i2 = i+2;
            N =(k*scale)-2;
            N1 =(k*scale)-1;
            N2 =(k*scale);
            
            Xdiff1 = (X(t,i1:N1)-X(t,i:N));
            Xdiff2 = (X(t,i2:N2)-X(t,i1:N1));
            Xdiff = Xdiff1.*Xdiff2;
            NT(t,k) = sum(sign(Xdiff(1:scale-2)));
        end
    end
