%% Calculate variance
% EMGvar(X,samples,scale,file)
% X:        Matrix containing the data,currenly assumed to contain 8 rows
%           of data. One for each electrode.
% samples:  # samples with new frequency.
% scale:    # times to scale down the signal.
% 
% VAR = (1/(N-1))*Sum((x_i)^2)
%
% Per Ferdinand Bach, perferdi@stud.ntnu.no
% $Revision: 1.5 $Date: 2009/01/21 13:00:00 $

function VAR = EMGvar(X,samples,scale)
    for k=1:samples
        i = (k-1)*scale+1;
        N =(k*scale)-1;
        for t=1:8;
            Xvar = X(t,i:N);
            VAR(t,k) = (1/(N-1))*sum(Xvar.^2);
        end
    end