%% Calculate Wilson amplitude
% EMGwamp(X,samples,scale,file)
% X:        Matrix containing the data,
%           currenly assumed to contain 8 rows
%           of data. One for each electrode.
% samples:  # samples with new frequency.
% scale:    # times to scale down the signal.
% 
% WAMP = Sum( |x_i - x_i+1|)
% threshold = 50mjuV?.
% Threshold depends on the gain of the electrode etc.
%
% Per Ferdinand Bach, perferdi@stud.ntnu.no
% $Revision: 1.5 $Date: 2009/01/21 13:00:00 $

function WAMP = EMGwamp(X,samples,scale) 
    thresh = 0.9; %0.35;%4e+03;
    for k=1:samples
        for t=1:8;
            i = (k-1)*scale+1;
            i1 = i+1;
            N =(k*scale)-1;
            Xwamp = X(t,i:N);
            Xwamp1 = X(t,i1:N+1); %x_i+1
            Xthresh = abs(Xwamp1-Xwamp);
            Xw = find(Xthresh>thresh);
            WAMP(t,k) = length(Xw);
        end
    end