%% Calculate wavelength
% EMGwave(X,samples,scale,file)
% X:        Matrix containing the data,currenly assumed to contain 8 rows
%           of data. One for each electrode.
% samples:  # samples with new frequency.
% scale:    # times to scale down the signal.
% 
% WAVE = Sum f(|x_i - x_i-1|)
% thresh = 50e-06;
%
% Per Ferdinand Bach, perferdi@stud.ntnu.no
% $Revision: 1.5 $Date: 2009/01/21 13:00:00 $

function WAVE = EMGwave(X,samples,scale) 
    for k=1:samples
        for t=1:8;
            i = (k-1)*scale+2;
            i1 = i+1;
            N =(k*scale)-1;
            Xwl = X(t,i:N);
            Xwl1 = X(t,i1:N+1); %x_i-1
            Xwave = abs(Xwl-Xwl1);
            WAVE(t,k) = sum(Xwave);
        end
    end