%% Calculate zero-crossings
% EMGzc(X,samples,scale,file)
% X:        Matrix containing the data,currenly assumed to contain 8 rows
%           of data. One for each electrode.
% samples:  # samples with new frequency.
% scale:    # times to scale down the signal.
% 
% ZC = Sum( sgn(-(x_i-x_i+1)))
%
% Per Ferdinand Bach, perferdi@stud.ntnu.no
% $Revision: 1.5 $Date: 2009/01/21 13:00:00 $

function ZC = EMGzc(X,samples,scale) 
    for k=1:samples
        for t=1:8;
            i = (k-1)*scale+1;
            Xs = sign(X(t,i:k*scale));
            Xdiff = diff(Xs)/2;
            ZC(t,k) = sum(abs(Xdiff));
        end
    end