%% Plot setup
% define how our figure should be viewed, and printed to pdf.
% TODO:
% Fix xlabel/ylabel for plots.

figure(1);
set(gcf,'Position',[600 500 800 200]);
set(gcf,'PaperUnits','Centimeters');
set(gcf,'PaperOrientation', 'Portrait');
set(gcf,'PaperSize',[19 5]);
set(gcf,'PaperPosition',[0 0 20 5]);

for i=1:length(subjects)
    for j=1:length(dataset)
        %% Retrive data
        plotRawData = [cell2mat(subjects(chosenFeature_user)) '_' cell2mat(dataset(chosenFeature_dataset))];
        load(['src/EMG/EMG_' plotRawData '.mat']);

        %% raw EMG signal
        plot(EMG(1,raw),EMG((chosenFeature_site+1),raw));
        title([cell2mat(EMGsite(chosenFeature_site)) ', person ' num2str(i) ', data set ' cell2mat(dataset(j)) ', ' chosenFeature_combination ' movements']);
        xlabel('Time (s)');
        ylabel('EMG [V]');
        ylim([-5,5]);
        print(1,'-dpdf',[dir_setup 'gfx/features/' cell2mat(lower(EMGsite(chosenFeature_site))) '_' cell2mat(subjects(chosenFeature_user)) '_' cell2mat(dataset(chosenFeature_dataset)) '_raw.pdf'])
        print(1,'-dpng','-r300',[dir_setup 'gfx/features/' cell2mat(lower(EMGsite(chosenFeature_site))) '_' cell2mat(subjects(chosenFeature_user)) '_' cell2mat(dataset(chosenFeature_dataset)) '_raw.png'])
        hold off;
        for r=1:length(features)
%            try
                plotFeatureData = [dir_setup 'features/EMG' cell2mat(features(r)) '/EMG_' cell2mat(features(r)) '_' cell2mat(subjects(i)) '_' cell2mat(dataset(j)) '.mat'];
                load(plotFeatureData);
                switch char(features(r))
                    case 'ar',
                        plot(trange,AR(chosenFeature_site,range,1),'b');
                        hold on;
                        plot(trange,AR(chosenFeature_site,range,2),'r');
                        hold on;
                        plot(trange,AR(chosenFeature_site,range,3),'g');
                    case 'cc',
                        plot(trange,CC(chosenFeature_site,range));
            %            xlabel('Quefrency (s)');
            %            ylabel('Cepstrum');
                    case 'ewc',
                        R = 0;
                        for k=1:length(EWC(chosenFeature_site,1,:))
                            R = R + EWC(chosenFeature_site,range,k);
                        end
                        plot(trange,R);
                        hold on;
                    case 'ewpc',
                        Q=0;
                        for k=2:10 %length(EWPC(chosenFeature_site,1,:))
                            Q = Q + EWPC(chosenFeature_site,range,k);
%                            hold on;
                        end
                        plot(trange,Q);
                    case 'hist',
%                         w = 1:numHistBins;
%                         maks = 0;
%                         HISTb = HIST(1,:,:);
%                         for z=2:numHistBins-1
%                             HISTb = [HISTb,HIST(z,:,:)];
%                         end
%                         clear HIST
%                         HIST = HISTb;
%                         for g=tmin*freq:tmax*freq;
%                             w = 1+(numHistBins-1)*numHistBins:g*numHistBins;
%                             if numHistBins>1
%                                 i1 = 1+(numHistBins-2)*9:(numHistBins-1)*n;
%                                 maks = maks + max(HIST(chosenFeature_site,i1));
%                             end
%                             plot((maks+HIST(chosenFeature_site,w)),[1:n]);
%                             hold on;
%                         end
%                         xlim([0 2020]);
        %            xlabel('Histogram');
        %            ylabel('Bucket');
                    case 'proc',
                    otherwise,
                        eval(['plot(trange,' cell2mat(upper(features(r))) '(' num2str(chosenFeature_site) ',range))']);
                end
                title([cell2mat(EMGsite(chosenFeature_site)) ', person ' num2str(i) ', data set ' cell2mat(dataset(j)) ', ' chosenFeature_combination ' movements']);
                xlabel('Time (s)');
                ylabel(upper(features(r)));
                print(1,'-dpdf',[dir_setup 'gfx/features/' cell2mat(subjects(i)) '/' cell2mat(dataset(j)) '/' cell2mat(features(r)) '_' cell2mat(lower(EMGsite(chosenFeature_site))) '_' cell2mat(subjects(i)) '_' cell2mat(dataset(j)) '_' datostreng '.pdf'])
                print(1,'-dpng','-r300',[dir_setup 'gfx/features/' cell2mat(subjects(i)) '/' cell2mat(dataset(j)) '/' cell2mat(features(r)) '_' cell2mat(lower(EMGsite(chosenFeature_site))) '_' cell2mat(subjects(i)) '_' cell2mat(dataset(j)) '_' datostreng '.png'])
                hold off;
%            catch
%                disp('Could not create plot. Skipping feature/subject/dataset..')
%            end
        end
    end
end