init
close all;
%% VARIABLES

%mkdir(['gfx/' subjects{get_subject} '/' dataset{get_dataset} '/']);
save_path = [dir_setup 'gfx/mapping/'];
rmse_path = [dir_setup 'results/'];
path = [dir_setup 'mapping/'];

% if variable combo is defined in init, we should plot combinations of
% features. We then need to load the combinations from a file.
if strcmp(combo,'true')
    combinations
end
%% GENERATE PLOT RANGE
% create time array.
Frange=tmin*freq+1:tmax*freq;
t = tmin+1/freq:1/freq:tmax;
Xrange = [tmin tmax];
%% LOAD DATA

if strcmp(combo,'true')
          feature_combo = cell2mat(combination(get_combination))
      else
          feature_combo = cell2mat(features(get_feature));
end

disp(['Method: ' cell2mat(classifier(method))])
switch char(classifier(method))
    case {'lf','qf'},
        filename = [rmse_path 'filtered/rmse_' cell2mat(classifier(method))];
        load(filename);
        load([path 'EMG' feature_combo '/DATA/XF_' feature_combo '_' subjects{get_subject} '_' order '_' cell2mat(classifier(method)) '_Estimated.mat']);
    case {'nn','rn'},
        filename = [rmse_path 'filtered/rmse_' cell2mat(classifier(method)) '_avg_' num2str(nBestLaps) 'run'];
        % Get the best data for each angle.
        load(filename);
        %test_id because that is what runFindLeastRMSE_nn saves.
        round = eval([cell2mat(subjects(get_subject)) '.' feature_combo '.angle' num2str(angle) '.rmse_' cell2mat(classifier(method)) '_test_id']);

        load([path 'EMG' feature_combo '/DATA/run' num2str(round(best_no)) '/XF_' feature_combo '_' subjects{get_subject} '_' order '_' cell2mat(classifier(method)) '_' num2str(nodeNo) '_nodes_Estimated.mat']);
end

%Define from where we want to get the data
%This has not been double checked. What if we change the order of the data
%set?
switch(cell2mat(type(get_dataset)))
    case 'train',
        disp('training set')
        %training set
        A = Fdata;
        B = F_e;
    case 'val',
        disp('validation set')
        %validation set
        A = Fval;
        B = Fval_e;
    case 'test',
        %test set
        disp('testing set')
        A = Ftest;
        B = Ftest_e;
end
%% PROCESS DATA
% Remove noise and average the signal

%err2 = A(angle,:) - B(angle,:);
%rmse2 = sqrt(mse(err2*180/pi));
%pst2 = rmse2/(angleROM(angle)/100);
%text_rmse2 = num2str(sprintf('%.2f',rmse2/(angleROM(angle)/100)));
%coeffs2 = corrcoef(A(angle,:),B(angle,:));
%corrcoeffs2 = coeffs2(1,2);
%theta2 = dot(A(angle,:),B(angle,:))/(norm(A(angle,:))*norm(B(angle,:)));
%ufiltrert = [pst2 corrcoeffs2 theta2]

G = B(angle,:);
%Frange2=(0.3+tmin)*freq+1:(0.3+tmax)*freq;
%R = lpfilter(B(angle,Frange),Klowpass,Flowpass);
H = smoothing(G,smooth_const);
R = H(Frange);
err = A(angle,:) - H;

rmse=sqrt(mse(err*180/pi));
pst=rmse/(angleROM(angle)/100);
text_rmse = num2str(sprintf('%.2f',rmse/(angleROM(angle)/100)));
coeffs = corrcoef(A(angle,:),H);
corrcoeffs = coeffs(1,2);
theta = dot(A(angle,:),H)/(norm(A(angle,:))*norm(H));
filtrert = [pst,corrcoeffs,theta]
%% PLOT AND SAVE
combination_text = strrep(feature_combo,'_',' ');
g = 1; %figure number
figure(g)
set(gcf,'Position',[0 800 1300 185]);
set(gcf,'PaperUnits','Centimeters');
set(gcf,'PaperOrientation', 'Portrait');
set(gcf,'PaperSize',[19 5]); %35
set(gcf,'PaperPosition',[-1.5 0 22 5]); %35

% plot(t,A(angle,Frange)*180/pi,'k');
% ylabel('Angle [deg]');
% xlabel('Time [seconds]');
% title(['Person: ' subjects{get_subject} ', set: ' dataset{get_dataset} ', feature: ' combination_text ', measured angles']);
% grid on;
% 
% print(g,'-dpdf','-r300',[save_path subjects{get_subject} '/' dataset{get_dataset} '/RMSE_LT_measured_angles_' num2str(aNshort(angle,:)) '_' datostreng '.pdf'])
% print(g,'-dpng','-r300',[save_path subjects{get_subject} '/' dataset{get_dataset} '/RMSE_LT_measured_angles_' num2str(aNshort(angle,:)) '_' datostreng '.png'])
% 
% g = g+1;
% 
% figure(g)
% set(gcf,'Position',[0 540 800 185]); %1677
% set(gcf,'PaperUnits','Centimeters');
% set(gcf,'PaperOrientation', 'Portrait');
% set(gcf,'PaperSize',[20 5]);
% set(gcf,'PaperPosition',[0 0 20 5]);

plot(t,B(angle,Frange)*180/pi);
hold on;
plot(t,A(angle,Frange)*180/pi,'k');
hold off;
ylabel('Angle [deg]');
xlabel('Time [seconds]');
%title(['Method: ' cell2mat(classifier(method)) ', person: ' subjects{get_subject} ', set: ' dataset{get_dataset} ', feature: ' combination_text ', angle: ' aNshort(angle,:) ', rmse: ' text_rmse2 '%']);
grid on;
legend('Measured','estimated','Location','NorthEastOutside')
print(g,'-dpdf','-r300',[save_path subjects{get_subject} '/' dataset{get_dataset} '/RMSE_LT_' subjects{get_subject} '_' dataset{get_dataset} '_'  feature_combo '_' cell2mat(classifier(method)) '_raw_' num2str(aNshort(angle,:)) '_' datostreng '.pdf'])
print(g,'-dpng','-r300',[save_path subjects{get_subject} '/' dataset{get_dataset} '/RMSE_LT_' subjects{get_subject} '_' dataset{get_dataset} '_'  feature_combo '_' cell2mat(classifier(method)) '_raw_' num2str(aNshort(angle,:)) '_' datostreng '.png'])
g = g+1;

figure(g)
set(gcf,'Position',[0 540 1300 185]); %1677
set(gcf,'PaperUnits','Centimeters');
set(gcf,'PaperOrientation', 'Portrait');
set(gcf,'PaperSize',[19 5]);
set(gcf,'PaperPosition',[-1.5 0 22 5]);

% set(gcf,'Position',[0 280 800 185]);
% set(gcf,'PaperUnits','Centimeters');
% set(gcf,'PaperOrientation', 'Portrait');
% set(gcf,'PaperSize',[20 5]);
% set(gcf,'PaperPosition',[0 0 20 5]);

% plot(t,R*180/pi);
% ylabel('Angle [deg]');
% xlabel('Time [seconds]');
% title(['Method: ' cell2mat(classifier(method)) ', person: ' subjects{get_subject} ', set: ' dataset{get_dataset} ', feature: ' combination_text ', angle: ' aNshort(angle,:) ' ']);
% grid on;
% 
% print(g,'-dpdf','-r300',[save_path subjects{get_subject} '/' dataset{get_dataset} '/RMSE_LT_' subjects{get_subject} '_' dataset{get_dataset} '_'  feature_combo '_' cell2mat(classifier(method)) '_smoothed' num2str(smooth_const) '_' num2str(aNshort(angle,:)) '_' datostreng '.pdf'])
% print(g,'-dpng','-r300',[save_path subjects{get_subject} '/' dataset{get_dataset} '/RMSE_LT_' subjects{get_subject} '_' dataset{get_dataset} '_'  feature_combo '_' cell2mat(classifier(method)) '_smoothed' num2str(smooth_const) '_' num2str(aNshort(angle,:)) '_' datostreng '.png'])
% 
% g = g+1;
% figure(g)
% set(gcf,'Position',[0 31 800 185]);
% set(gcf,'PaperUnits','Centimeters');
% set(gcf,'PaperOrientation', 'Portrait');
% set(gcf,'PaperSize',[20 5]);
% set(gcf,'PaperPosition',[0 0 20 5]);
% 
%plot(t,B(angle,Frange)*180/pi,'r');
%hold on;


plot(t,A(angle,Frange)*180/pi,'k');
hold on;
plot(t,R*180/pi);
hold off;
ylabel('Angle [deg]');
xlabel('Time [seconds]');
%title(['Method: ' cell2mat(classifier(method)) ', person: ' subjects{get_subject} ', set: ' dataset{get_dataset} ', feature: ' combination_text ', angle: ' aNshort(angle,:) ', rmse: ' text_rmse '%']);
grid on;

%if method==1
legend('Measured','estimated','Location','NorthEastOutside')
%else
 %   legend('Measured angles','neural network','Location','NorthEastOutside')
%end

print(g,'-dpdf','-r300',[save_path subjects{get_subject} '/' dataset{get_dataset} '/RMSE_LT_' subjects{get_subject} '_' dataset{get_dataset} '_'  feature_combo '_' cell2mat(classifier(method)) '_measured_angles_smoothed' num2str(smooth_const) '_' num2str(aNshort(angle,:)) '_' datostreng '.pdf'])
print(g,'-dpng','-r300',[save_path subjects{get_subject} '/' dataset{get_dataset} '/RMSE_LT_' subjects{get_subject} '_' dataset{get_dataset} '_'  feature_combo '_' cell2mat(classifier(method)) '_measured_angles_smoothed' num2str(smooth_const) '_' num2str(aNshort(angle,:)) '_' datostreng '.png'])