%% plotRMSE for LF/QF ..
% Define what plot you want by altering plotMappingF in init.m
% We want to plot the RMSE of all the features, for each subject, and for
% each angle.
close all;
%% LOADING DATA FROM RMSE CALCULATION
path = [dir_setup 'results/'];
filename = ([path 'rmse_' plotMappingF '.mat']);
load(filename);

clear x;

gfx_path = [dir_setup 'gfx/mapping/'];

if strcmp(feature_subset,'true')
    combinations
    cf = length(combination);
else
    cf = length(features);
end

for g=1:length(angleROM);
  %% TEST
    fid = fopen([gfx_path 'RMSE_' plotMappingF '_' aNshort(g,:) '_' datostreng '.txt'],'w');
    disp(angleNames(g,:))
    a = sprintf([angleNames(g,:) '\\\r\n']);
    c = fwrite(fid,a);
    for k=1:cf
      if strcmp(feature_subset,'true')
          feature_combo = cell2mat(combination(k));
      else
          feature_combo = cell2mat(features(k));
      end
      for l=1:length(subjects)
           try
              eval(['x(' num2str(l) ',' num2str(k) ') = ' cell2mat(subjects(l)) '.' feature_combo '.angle' num2str(g) '.rmse_' plotMappingF '_' cell2mat(type(print_type)) ';']); %plotting the best result (test(1))c
           catch
               eval(['x(' num2str(l) ',' num2str(k) ') = ' cell2mat(subjects(l)) '.' feature_combo '.angle' num2str(g) '.rmse_' cell2mat(type(print_type)) ';']); %plotting the best result (test(1))c
               if l==1 && k==1
                 disp('plotting from old data file, mapping function is LF..')
                 plotMappingF = 'lf';
               end
           end
          eval(['x(' num2str(l) ',' num2str(k) ') = x(' num2str(l) ',' num2str(k) ')/(' num2str(angleROM(g)) '/100);'])
      end
      if mod(k,2)
          a = sprintf([feature_combo ' & ' num2str(sprintf('%.2f',x(persona,k))) ' & ' num2str(sprintf('%.2f',x(persona,k)/(angleROM(g)/100)))]);     
      else     
          a = sprintf([' & ' feature_combo ' & ' num2str(sprintf('%.2f',x(persona,k))) ' & ' num2str(sprintf('%.2f',x(persona,k)/(angleROM(g)/100))) '\\\r\n']);          
      end
      c = fwrite(fid,a);
    end

  %% PLOTTING
   figure(g)
   bar(x,'group');
   
   if strcmp(feature_subset,'true')
     combination_text = strrep(combination,'_',' ');
     legend(combination_text,'Location','NorthEastOutside');
   else
     legend(features,'Location','NorthEastOutside');
   end
   ylabel('RMSE [% of ROM]');
 %  ylabel('RMSE [deg]');
   xlabel('Subject');
%   set(gca,'xticklabel',str2mat('1','2','3'));
   title([ upper(plotMappingF) ' estimation. ' cell2mat(type(print_type)) ': ' num2str(angleNames(g,:))]);
   grid on;
   hold on;
   set(gcf,'paperunits','centimeters');
   set(gcf,'PaperOrientation', 'Portrait');
   set(gcf,'papersize',[12 11]),
   set(gcf,'paperposition',[0 0 13 11]);
   print(g,'-dpdf','-r300',[gfx_path 'RMSE_' plotMappingF '_' num2str(aNshort(g,:)) '_' datostreng '.pdf'])
   print(g,'-dpng','-r300',[gfx_path 'RMSE_' plotMappingF '_' num2str(aNshort(g,:)) '_' datostreng '.png'])
   fclose(fid);
end