%% FindBestFeaturesCORR
% Find the nBestFeatures based on CORR for a certain Angle.

% Trying to find the best Feature combination amongst those tested.
% It should be filtered on the validation data, and then plotted or shown
% values for test data set.
clc

%% LOADING DATA FROM CORR CALCULATION
path = [dir_setup 'mapping/'];
save_path = [dir_setup 'results/'];

if strcmp(feature_subset,'true')
    combinations;
    cf = length(combination);
else
    cf = length(features);
end

%aNum=3;
klass=2;
type='val';

%Loading the file that contains all RMSE data.
if klass==1
    file='corr_lf.mat';
else
    file='corr_nn_avg_10run.mat';
end

load([save_path file]);

%Preallocate space for matrix to contain data
sortArray = zeros(cf,4);
ArrayTest = zeros(cf,4);
Longest = 0;
for i=1:cf
    if strcmp(feature_subset,'true')
	  feature_combo = cell2mat(combination(i));
    else
        feature_combo = cell2mat(features(i));
    end
   % Want to find the longest name of a feature. This to print a more
   % readable table of data in Matlab.
    tmp = length(feature_combo);
    if tmp>Longest;
        Longest = tmp;
    end
    for j=2:2 %length(subjects)
        %Gather the desired data from the specified file/struct.
        for k=1:length(angleROM)
             if klass==1
                 fTure = abs(mean(eval([cell2mat(subjects(j)) '.' feature_combo '.angle' num2str(k) '.corr_' cell2mat(classifier(klass)) '_val(1)'])));
                 fTureTest = abs(mean(eval([cell2mat(subjects(j)) '.' feature_combo '.angle' num2str(k) '.corr_' cell2mat(classifier(klass)) '_' type '(1)']))); 
             else
                fTure = abs(mean(eval([cell2mat(subjects(j)) '.' feature_combo '.angle' num2str(k) '.corr_' cell2mat(classifier(klass)) '_val(1:5)'])));
                fTureTest = abs(mean(eval([cell2mat(subjects(j)) '.' feature_combo '.angle' num2str(k) '.corr_' cell2mat(classifier(klass)) '_' type '(1:5)'])));
             end
            % Creates an Array to be Sorted.
            sortArray(i,k)=fTure;
            ArrayTest(i,k)=fTureTest;
            %eval(['sortArrayRMSE_' aNshort(k,:) '(' num2str(i-16) ')=' num2str(fTure) ';']);
        end
    end
end
% Sort the array, and saves the order features are sorted, as well as the
% data.
[Xsorted,xid] = sortrows(sortArray,2);
Ftext = 'Feature combination';
WhiteSpace = '';
for y=length(Ftext):Longest
        WhiteSpace = strcat(WhiteSpace,'-');
end
Ftext = strcat(Ftext,WhiteSpace);
Ftext = strrep(Ftext,'-',' ');
    disp('Best feature subsets based on CORR from validation data set..')
    disp(' ')
    text = sprintf('#\t%s\tWFE\t\t\tPercent\t\t\tPS\t\t\tPercent\t\t\tFFE\t\t\tPercent\t\t\tRUD\t\t\tPercent\n',Ftext);
    disp(text)
for i=1:cf
    % Here we add "whitespace" to the end of a feature name to get the same
    % length as the longest feature.
    featureName=cell2mat(combination(xid(i)));
    WhiteSpace = '';
    for y=length(featureName):Longest
        WhiteSpace = strcat(WhiteSpace,'-');
    end
    featureName = strcat(featureName,WhiteSpace);
    featureName = strrep(featureName,'-',' ');
    
    % Time to print the values.
    text = sprintf('%d\t%s\t%.2f\t\t%.2f%%\t\t\t%.2f\t\t%.2f%%\t\t\t%.2f\t\t%.2f%%\t\t\t%.2f\t\t%.2f%%',xid(i),featureName, ...
    ArrayTest(xid(i),2)*180/pi,ArrayTest(xid(i),2)*180/pi/(angleROM(2)/100), ...
    ArrayTest(xid(i),3)*180/pi,ArrayTest(xid(i),3)*180/pi/(angleROM(3)/100), ...
    ArrayTest(xid(i),1)*180/pi,ArrayTest(xid(i),1)*180/pi/(angleROM(1)/100), ...
    ArrayTest(xid(i),4)*180/pi,ArrayTest(xid(i),4)*180/pi/(angleROM(4)/100));
    disp(text);
%      text = sprintf('%s\t%.2f\t\t%.2f%%\t\t\t%.2f\t\t%.2f%%\t\t\t%.2f\t\t%.2f%%\t\t\t%.2f\t\t%.2f%%',featureName, ...
%      Xsorted(i,2),Xsorted(i,2)/(angleROM(2)/100), ...
%      Xsorted(i,3),Xsorted(i,3)/(angleROM(3)/100), ...
%      Xsorted(i,1),Xsorted(i,1)/(angleROM(1)/100), ...
%      Xsorted(i,4),Xsorted(i,4)/(angleROM(4)/100));
%      disp(text);
end

