%% FindBestFeaturesRMSE
% Find the nBestFeatures based on RMSE for a certain Angle.

% Trying to find the best Feature combination amongst those tested.
% It should be filtered on the validation data, and then plotted or shown
% values for test data set.
init
%% LOADING DATA FROM RMSE CALCULATION
path = [dir_setup 'mapping/'];
save_path = [dir_setup 'results/'];
%feature_subset=false;
if strcmp(feature_subset,'true')
    combinations;
    cf = length(combination);
else
    cf = length(features);
end

%cf=15;
klass=2;
type='val';
performance='rmse'; %'rmse','cst'

%Loading the file that contains all RMSE data.
if klass==1
    file=[performance '_lf.mat'];
%    file=['filtered/' performance '_lf.mat'];
%    file=['unfiltered/' performance '_lf.mat'];
else
    file=[performance '_nn_avg_10run.mat'];
%    file=['filtered/' performance '_nn_avg_10run.mat']; 
%    file=['unfiltered/' performance '_nn_avg_10run.mat'];    
end

load([save_path file]);

%Preallocate space for matrix to contain data
sortArray = zeros(cf,4);
ArrayTest = zeros(cf,4);
xlsArray = zeros(10,cf);
Longest = 0;
  for i=1:cf
    if strcmp(feature_subset,'true')
	  feature_combo = cell2mat(combination(i));
    else
        feature_combo = cell2mat(features(i));
    end
   % Want to find the longest name of a feature. This to print a more
   % readable table of data in Matlab.
    tmp = length(feature_combo);
    if tmp>Longest;
        Longest = tmp;
    end
        %Gather the desired data from the specified file/struct.
        for k=1:length(angleROM)
            TureId=0;
          for j=1:length(subjects)
            if klass==1
                tmp = eval([cell2mat(subjects(j)) '.' feature_combo '.angle' num2str(k) '.' performance '_' cell2mat(classifier(klass)) '_val(1)']);
                if(tmp>0 || tmp<0)
                    TureId=TureId+1;
                    fTure(TureId) = tmp;
                    fTureTest(TureId) = eval([cell2mat(subjects(j)) '.' feature_combo '.angle' num2str(k) '.' performance '_' cell2mat(classifier(klass)) '_' type '(1)']);
                end
            else
                tmp = mean(eval([cell2mat(subjects(j)) '.' feature_combo '.angle' num2str(k) '.' performance '_' cell2mat(classifier(klass)) '_val(1:5)']));
                if(tmp>0 || tmp<0)
                    TureId=TureId+1;
                    fTure(TureId) = tmp;
                    fTureTest(TureId) = mean(eval([cell2mat(subjects(j)) '.' feature_combo '.angle' num2str(k) '.' performance '_' cell2mat(classifier(klass)) '_' type '(1:5)']));
                end
            end
          end
            % Creates an Array to be Sorted.
%            sortArray(i,k)=mean(fTure);
%            ArrayTest(i,k)=mean(fTureTest);
            sortArray(i,k)=mean(abs(fTure));
           ArrayTest(i,k)=mean(abs(fTureTest));
            clear fTure fTureTest
            %eval(['sortArrayRMSE_' aNshort(k,:) '(' num2str(i-16) ')=' num2str(fTure) ';']);
        end
  end
   
% Sort the array, and saves the order features are sorted, as well as the
% data. Sort data on wfe angle, because this is the most important one,
% next could be ps, but possibly because of too few nodes in nn it did not
% perform very well.
if strcmp(performance,'rmse')
    [Xsorted,xid] = sortrows(sortArray,[2 4 1 3]);
else
    [Xsorted,xid] = sortrows(sortArray,[-2 -3 -1 -4]);
end
Ftext = 'Feature combination';
WhiteSpace = '';
for y=length(Ftext):Longest
        WhiteSpace = strcat(WhiteSpace,'-');
end
Ftext = strcat(Ftext,WhiteSpace);
Ftext = strrep(Ftext,'-',' ');
    disp(' ')
    disp(['Best feature subsets based on ' upper(performance) ' from validation data set ' upper(cell2mat(classifier(klass))) '..'])
    disp(' ')
    text = sprintf('#\t%s\tWFE\t\tPst\t\tPS\t\tPst\t\tFFE\t\tPst\t\tRUD\t\tPst\n',Ftext);
    %text = sprintf('#\t%s\tWFE\tpst\tPS\tpst\tFFE\tpst\tRUD\tPercent\n',Ftext);
    disp(text)
  for i=1:cf
    % Here we add "whitespace" to the end of a feature name to get the same
    % length as the longest feature.
    if strcmp(feature_subset,'true')
        featureName=cell2mat(combination(xid(i)));
    else
        featureName=cell2mat(features(xid(i))); 
    end

    WhiteSpace = '';
    for y=length(featureName):Longest
        WhiteSpace = strcat(WhiteSpace,'-');
    end
%    featureName = strcat(featureName,WhiteSpace);
    featureName = strrep(featureName,'-',' ');
    
    % Time to print the values.
    if strcmp(performance,'rmse')
        text = sprintf('%d\t%s\t%.2f\t%.2f%%\t%.2f\t%.2f%%\t%.2f\t%.2f%%\t%.2f\t%.2f%%',xid(i),featureName, ...
        ArrayTest(xid(i),2),ArrayTest(xid(i),2)/(angleROM(2)/100), ...
        ArrayTest(xid(i),3),ArrayTest(xid(i),3)/(angleROM(3)/100), ...
        ArrayTest(xid(i),1),ArrayTest(xid(i),1)/(angleROM(1)/100), ...
        ArrayTest(xid(i),4),ArrayTest(xid(i),4)/(angleROM(4)/100));
         text2 = sprintf('%d & %.2f & %.2f',xid(i), ... %,featureName, ...
        ArrayTest(xid(i),2)/(angleROM(2)/100), ...             
        ArrayTest(xid(i),1)/(angleROM(1)/100)); %, ...
%        ArrayTest(xid(i),3)/(angleROM(3)/100), ...        
%        ArrayTest(xid(i),4)/(angleROM(4)/100));
        text3 ='';
    else
        text2 = sprintf('%d & %.3f & %.3f',xid(i), ... %featureName, ...
        ArrayTest(xid(i),2), ...
        ArrayTest(xid(i),1)); %, ...        
%        ArrayTest(xid(i),3), ...
 %      ArrayTest(xid(i),4));
       text3 = sprintf('%.2f', ...
        ArrayTest(xid(i),2)); %, ...
    end
    disp(text2);
%      disp(text3);
  end

clear sortArray ArrayTest xlsArray Xsorted xid