%% calculatePerformance
% This file loops through all features, subjects and classifiers specified
% in init.m, and calculate the RMSE,Correlation coefficent and similarity transform. 
% Data is then saved for each classifier. 

error = 0;
path = [dir_setup 'mapping/'];
warning off MATLAB:MKDIR:DirectoryExists;

if strcmp(feature_subset,'true')
    combinations
    cf = length(combination);
    warning off MATLAB:MKDIR:DirectoryExists;
else
    cf = length(features);
end

for i=1:cf
    if strcmp(feature_subset,'true')
	  feature_combo = cell2mat(combination(i));
    else
        feature_combo = cell2mat(features(i));
    end
    disp(['Calculating performance on feature ' upper(feature_combo)])
    for k=1:length(classifier)
        disp(sprintf(['using estimation function: ' upper(cell2mat(classifier(k))) '\n']))
    	switch char(classifier(k))
            case 'lf', % LINEAR MAPPING FUNCTION
                mkdir([path 'EMG' feature_combo '/Performance/']);
                filename = [path 'EMG' feature_combo '/Performance/performance_' feature_combo '_' cell2mat(classifier(k)) '_angleSpecific.mat'];
                filepath = [path 'EMG' feature_combo '/DATA/'];
                warning off MATLAB:DELETE:fileNotFound
                delete(filename);
                
                for j=1:length(subjects)
                    for no = 1:4
                        retur = calculatePerformance_angleSpecific(cell2mat(subjects(j)), num2str(order), no, feature_combo,filepath,cell2mat(classifier(k)));
                        eval([ cell2mat(subjects(j)) '.angle(no).rmse_' cell2mat(classifier(k)) '_train   = retur.rmse_train;']);
                        eval([ cell2mat(subjects(j)) '.angle(no).rmse_' cell2mat(classifier(k)) '_val     = retur.rmse_val;']);
                        eval([ cell2mat(subjects(j)) '.angle(no).rmse_' cell2mat(classifier(k)) '_test    = retur.rmse_test;']);
                        eval([ cell2mat(subjects(j)) '.angle(no).correlation_' cell2mat(classifier(k)) '_train = retur.correlation_train;']);
                        eval([ cell2mat(subjects(j)) '.angle(no).correlation_' cell2mat(classifier(k)) '_val   = retur.correlation_val;']);
                        eval([ cell2mat(subjects(j)) '.angle(no).correlation_' cell2mat(classifier(k)) '_test  = retur.correlation_test;']);
                        eval([ cell2mat(subjects(j)) '.angle(no).cst_' cell2mat(classifier(k)) '_train = retur.cst_train;']);
                        eval([ cell2mat(subjects(j)) '.angle(no).cst_' cell2mat(classifier(k)) '_val   = retur.cst_val;']);
                        eval([ cell2mat(subjects(j)) '.angle(no).cst_' cell2mat(classifier(k)) '_test  = retur.cst_test;']);
                    end
                    
                    if ~error
                        try
                           	save(filename,cell2mat(subjects(j)),'-append');
                        catch couldNotWriteFile
                            save(filename,cell2mat(subjects(j)));
                        end
                    else
                        disp(sprintf(['Error occured, should stop now..\n']))
                        error = 0;
                    end
                end
            case 'qf', % QUADRATIC MAPPING FUNCTION
                filename = [path 'EMG' feature_combo '/Performance/performance_' feature_combo '_' cell2mat(classifier(k)) '_angleSpecific.mat'];
                filepath = [path 'EMG' feature_combo '/DATA/'];
                warning off MATLAB:DELETE:fileNotFound
                delete(filename);
                
                for j=1:length(subjects)
                    %disp(['using subject ' upper(cell2mat(subjects(j)))])
                    for no = 1:4
                        try
                            retur = calculatePerformance_angleSpecific(cell2mat(subjects(j)), num2str(order), no, feature_combo,filepath,cell2mat(classifier(k)));
                        catch unassignedOutputs
                            disp('Could not calculate Performance. Check init.m')
                            error = 1;
                            break
                        end
                        eval([ cell2mat(subjects(j)) '.angle(no).rmse_' cell2mat(classifier(k)) '_train   = retur.rmse_train;']);
                        eval([ cell2mat(subjects(j)) '.angle(no).rmse_' cell2mat(classifier(k)) '_val     = retur.rmse_val;']);
                        eval([ cell2mat(subjects(j)) '.angle(no).rmse_' cell2mat(classifier(k)) '_test    = retur.rmse_test;']);
                        eval([ cell2mat(subjects(j)) '.angle(no).correlation_' cell2mat(classifier(k)) '_train = retur.correlation_train;']);
                        eval([ cell2mat(subjects(j)) '.angle(no).correlation_' cell2mat(classifier(k)) '_val   = retur.correlation_val;']);
                        eval([ cell2mat(subjects(j)) '.angle(no).correlation_' cell2mat(classifier(k)) '_test  = retur.correlation_test;']);
                        eval([ cell2mat(subjects(j)) '.angle(no).cst_' cell2mat(classifier(k)) '_train = retur.cst_train;']);
                        eval([ cell2mat(subjects(j)) '.angle(no).cst_' cell2mat(classifier(k)) '_val   = retur.cst_val;']);
                        eval([ cell2mat(subjects(j)) '.angle(no).cst_' cell2mat(classifier(k)) '_test  = retur.cst_test;']);
                    end
                    if ~error
                    	try
                           	save(filename,cell2mat(subjects(j)),'-append');
                        catch couldNotWriteFile
                            save(filename,cell2mat(subjects(j)));
                        end
                    else
                        disp(sprintf(['Error occured, should stop now..\n']))
                        error = 0;
                    end
                end
            case 'nn', %NEURAL NETWORK
                for a=1:run
                    mkdir([path 'EMG' feature_combo '/Performance/run' num2str(a) '/']);
                    filename = [path 'EMG' feature_combo '/Performance/run' num2str(a) '/performance_' feature_combo '_' cell2mat(classifier(k)) '_angleSpecific.mat'];
                    filepath = [path 'EMG' feature_combo '/DATA/run' num2str(a) '/'];
                    warning off MATLAB:DELETE:fileNotFound
                    delete(filename);
                
                    for j=1:length(subjects)
                        %disp(['using subject ' upper(cell2mat(subjects(j)))])
                        for l=1:size(nodes,2)
                            for no = 1:4
                                retur = calculatePerformance_angleSpecific(cell2mat(subjects(j)), num2str(order), no, feature_combo,filepath,cell2mat(classifier(k)),'HiddenNodes',nodes(l));
                                eval([ cell2mat(subjects(j)) '.angle(no).rmse_' cell2mat(classifier(k)) '_train   = retur.rmse_train;']);
                                eval([ cell2mat(subjects(j)) '.angle(no).rmse_' cell2mat(classifier(k)) '_val     = retur.rmse_val;']);
                                eval([ cell2mat(subjects(j)) '.angle(no).rmse_' cell2mat(classifier(k)) '_test    = retur.rmse_test;']);
                                eval([ cell2mat(subjects(j)) '.angle(no).correlation_' cell2mat(classifier(k)) '_train = retur.correlation_train;']);
                                eval([ cell2mat(subjects(j)) '.angle(no).correlation_' cell2mat(classifier(k)) '_val   = retur.correlation_val;']);
                                eval([ cell2mat(subjects(j)) '.angle(no).correlation_' cell2mat(classifier(k)) '_test  = retur.correlation_test;']);
                                eval([ cell2mat(subjects(j)) '.angle(no).cst_' cell2mat(classifier(k)) '_train = retur.cst_train;']);
                                eval([ cell2mat(subjects(j)) '.angle(no).cst_' cell2mat(classifier(k)) '_val   = retur.cst_val;']);
                                eval([ cell2mat(subjects(j)) '.angle(no).cst_' cell2mat(classifier(k)) '_test  = retur.cst_test;']);
                            end
                        end
                        if ~error
                            try
                                save(filename,cell2mat(subjects(j)),'-append');
                            catch couldNotWriteFile
                                save(filename,cell2mat(subjects(j)));
                            end
                        else
                            disp(sprintf(['Error occured, should stop now..\n']))
                            error = 0;
                        end
                    end
                end
            case 'rn', % RECURRENT NEURAL NETWORK
                for a=1:run
                    try
                        filename = [path 'EMG' feature_combo '/Performance/run' num2str(a) '/performance_' feature_combo '_' cell2mat(classifier(k)) '_angleSpecific.mat'];
                        filepath = [path 'EMG' feature_combo '/DATA/run' num2str(a) '/'];
                        warning off MATLAB:DELETE:fileNotFound
                        delete(filename);
    
                        for j=1:length(subjects)
                            %disp(['using subject ' upper(cell2mat(subjects(j)))])
                            for l=1:size(nodes,2)
                                for no = 1:4
                                    try
                                        retur = calculatePerformance_angleSpecific(cell2mat(subjects(j)), num2str(order), no, feature_combo,filepath,cell2mat(classifier(k)),'HiddenNodes',nodes(l));
                                    catch unassignedOutputs
                                        disp('Could not calculate Performance. Check init.m')
                                        error = 1;
                                        break
                                    end
                                    eval([ cell2mat(subjects(j)) '.angle(no).rmse_' cell2mat(classifier(k)) '_train   = retur.rmse_train;']);
                                    eval([ cell2mat(subjects(j)) '.angle(no).rmse_' cell2mat(classifier(k)) '_val     = retur.rmse_val;']);
                                    eval([ cell2mat(subjects(j)) '.angle(no).rmse_' cell2mat(classifier(k)) '_test    = retur.rmse_test;']);
                                    eval([ cell2mat(subjects(j)) '.angle(no).correlation_' cell2mat(classifier(k)) '_train = retur.correlation_train;']);
                                    eval([ cell2mat(subjects(j)) '.angle(no).correlation_' cell2mat(classifier(k)) '_val   = retur.correlation_val;']);
                                    eval([ cell2mat(subjects(j)) '.angle(no).correlation_' cell2mat(classifier(k)) '_test  = retur.correlation_test;']);
                                    eval([ cell2mat(subjects(j)) '.angle(no).cst_' cell2mat(classifier(k)) '_train = retur.cst_train;']);
                                    eval([ cell2mat(subjects(j)) '.angle(no).cst_' cell2mat(classifier(k)) '_val   = retur.cst_val;']);
                                    eval([ cell2mat(subjects(j)) '.angle(no).cst_' cell2mat(classifier(k)) '_test  = retur.cst_test;']);
                                end
                            end
                            if ~error
                                try
                                    save(filename,cell2mat(subjects(j)),'-append'); % want to append all subjects to same file.
                                catch couldNotWriteFile
                                    save(filename,cell2mat(subjects(j))); % if no file is presentv
                                end
                            else
                                disp(sprintf(['Error occured, should stop now..\n']))
                                error = 0;
                            end
                        end
                    catch couldNotReadFile
                        break;
                    end
                end
        end
	end
end