%% FindLeastRMSE
% Find the nBestLaps best RMSE for each feature for Neural Network.

%% LOADING DATA FROM RMSE CALCULATION
path = [dir_setup 'mapping/'];
save_path = [dir_setup 'results/'];

if strcmp(feature_subset,'true')
    combinations
    cf = length(combination);
else
    cf = length(features);
end

numNeural = {};
% Check what kind of neural network we have. 
if cell2mat(regexp(classifier,'nn'))
    numNeural = {'nn'};
end
if cell2mat(regexp(classifier,'rn'))
    numNeural(length(numNeural)+1) = {'rn'};
end
for nn=1:length(numNeural)
    b = run;
    for a=1:run
        try
            for i=1:cf
                if strcmp(feature_subset,'true')
                    feature_combo = cell2mat(combination(i));
                else
                    feature_combo = cell2mat(features(i));
                end
                filename = [path 'EMG' feature_combo '/Performance/run' num2str(a) '/performance_' feature_combo '_' cell2mat(numNeural(nn)) '_angleSpecific.mat'];
                load(filename);
                for j=1:length(subjects)
                    eval([feature_combo '.run' num2str(a) '.' cell2mat(subjects(j)) ' = ' cell2mat(subjects(j)) ';']);
                    eval(['clear ' cell2mat(subjects(j))])
                end
            end
        catch couldNotReadFile
            disp('error')
            b = b-1;
            break;
        end
    end
    run = b;

    %% VALIDATION
    %for each feature, place each run in the array, then sort array and use
    %the n best results for each angle, for every subject.
    for d=1:length(subjects)
        fid(d) = fopen([save_path '/RMSE_' cell2mat(numNeural(nn)) '_' subjects{d} '_' num2str(nBestLaps) '_best_runs_' datostreng '.txt'],'w');
        for g=1:length(angleROM)
            angle_text = sprintf([ angleNames(g,:) '\r\n']);
            disp(angleNames(g,:))
            for k=1:cf
                if strcmp(feature_subset,'true')
                    feature_combo = cell2mat(combination(k));
                else
                    feature_combo = cell2mat(features(k));
                end
                for a=1:run
                    eval(['x(' num2str(a) ') = ' feature_combo '.run' num2str(a) '.' cell2mat(subjects(d)) '.angle(g).rmse_' cell2mat(numNeural(nn)) '_val;']);
                end
                [Xsorted,xid] = sort(x);
                for l=1:nBestLaps
                    eval([cell2mat(subjects(d)) '.' feature_combo '.angle' num2str(g) '.rmse_' cell2mat(numNeural(nn)) '_train(' num2str(l) ') = ' feature_combo '.run' num2str(xid(l)) '.' cell2mat(subjects(d)) '.angle(g).rmse_' cell2mat(numNeural(nn)) '_train;']);
                    eval([cell2mat(subjects(d)) '.' feature_combo '.angle' num2str(g) '.rmse_' cell2mat(numNeural(nn)) '_val(' num2str(l) ')   = ' feature_combo '.run' num2str(xid(l)) '.' cell2mat(subjects(d)) '.angle(g).rmse_' cell2mat(numNeural(nn)) '_val;']);
                    eval([cell2mat(subjects(d)) '.' feature_combo '.angle' num2str(g) '.rmse_' cell2mat(numNeural(nn)) '_test(' num2str(l) ')  = ' feature_combo '.run' num2str(xid(l)) '.' cell2mat(subjects(d)) '.angle(g).rmse_' cell2mat(numNeural(nn)) '_test;']);
                    eval([cell2mat(subjects(d)) '.' feature_combo '.angle' num2str(g) '.rmse_' cell2mat(numNeural(nn)) '_test_id(' num2str(l) ') = ' num2str(xid(l)) ';']);
                end
                tekst1 = sprintf([ aNshort(g,:) '\t' feature_combo '\t' mat2str(xid(1:nBestLaps)) '\r\n']);
                c = fwrite(fid(d),tekst1);
            end
        end
        fclose(fid(d));

        filename = [save_path 'rmse_' cell2mat(numNeural(nn)) '_avg_' num2str(nBestLaps) 'run'];

        warning off MATLAB:DELETE:fileNotFound
        delete(filename);
        try
            save(filename,cell2mat(subjects(d)),'-append'); % want to append all subjects to same file.
        catch couldNotWriteFile
            save(filename,cell2mat(subjects(d))); % if no file is present
        end
    end
    for i=1:cf
        if strcmp(feature_subset,'true')
            feature_combo = cell2mat(combination(i));
        else
            feature_combo = cell2mat(features(i));
        end
        eval(['clear ' feature_combo])
    end
    clear i x Xsorted xid a j fid k g d c filename tekst1 l b
end
clear path save_path cf
