%% GET RMSE LF/QF/..
% This program uses the computed RMSE data files for each features.
% Edited to only change the way data is built in the struct.
% RMSE: subject.feature.angle(NO).rmse_mapping_type
% EX:   sv.myop.angle(1).rmse_lf_test

%% LOADING DATA FROM RMSE CALCULATION
path = [dir_setup 'mapping/'];
save_path = [dir_setup 'results/'];

if strcmp(feature_subset,'true')
    combinations
    cf = length(combination);
else
    cf = length(features);
end

%Find what mapping functions to calculate RMSE from.
numMapping = {};
if cell2mat(regexp(classifier,'lf'))
    numMapping = {'lf'};
end
if cell2mat(regexp(classifier,'qf'))
    numMapping(length(numMapping)+1) = {'qf'};
end

for lf=1:length(numMapping)
    for i=1:cf
        if strcmp(feature_subset,'true')
            feature_combo = cell2mat(combination(i));
        else
            feature_combo = cell2mat(features(i));
        end
        filename = [path 'EMG' feature_combo '/Performance/performance_' feature_combo '_' cell2mat(numMapping(lf)) '_angleSpecific.mat'];
        load(filename);

        for j=1:length(subjects)
            eval([feature_combo '_' cell2mat(subjects(j)) ' = ' cell2mat(subjects(j)) ';']);
            eval(['clear ' cell2mat(subjects(j))])
        end
    end

    for g=1:length(angleROM);
        for k=1:cf
            if strcmp(feature_subset,'true')
                feature_combo = cell2mat(combination(k));
            else
                feature_combo = cell2mat(features(k));
            end

            for j=1:length(subjects)
                eval([cell2mat(subjects(j)) '.' feature_combo '.angle' num2str(g) '.rmse_' cell2mat(numMapping(lf)) '_train  = ' feature_combo '_' cell2mat(subjects(j)) '.angle(' num2str(g) ').rmse_' cell2mat(numMapping(lf)) '_train;']);
                eval([cell2mat(subjects(j)) '.' feature_combo '.angle' num2str(g) '.rmse_' cell2mat(numMapping(lf)) '_val  = ' feature_combo '_' cell2mat(subjects(j)) '.angle(' num2str(g) ').rmse_' cell2mat(numMapping(lf)) '_val;']);
                eval([cell2mat(subjects(j)) '.' feature_combo '.angle' num2str(g) '.rmse_' cell2mat(numMapping(lf)) '_test  = ' feature_combo '_' cell2mat(subjects(j)) '.angle(' num2str(g) ').rmse_' cell2mat(numMapping(lf)) '_test;']);
            end
        end
    end

    filename = [save_path 'rmse_' cell2mat(numMapping(lf))];

    for i=1:length(subjects)
        try
            save(filename,cell2mat(subjects(i)),'-append'); % want to append all subjects to same file.
        catch couldNotWriteFile
            save(filename,cell2mat(subjects(i))); % if no file is present
        end
    end
end
