%% GENERATE MAPPING
% This file together with the init file defines what calculations to be
% computed.

%For l times, run through every subject i , loop through all features j listed.
%For all features listed, run each classifier/mapping function.
%If neural network run through k nodes.
%LF and quadratic functions will only be calculated once because they does
%not start with random initial conditions.

path = [dir_setup 'mapping/'];

if strcmp(feature_subset,'true')
    combinations % this file defines the subsets to be tested..
    for l=1:run
        for i=1:length(subjects)
            for j=1:length(combination)
                disp([num2str(length(combination)) ' combinations to be calculated'])
                disp(['Features to be combined now: ' combination{j}])
                for k=1:length(classifier)
                        switch char(classifier(k))
                            case {'lf','qf'},
                                if l==1
                                    mkdir([path 'EMG' cell2mat(combination(j)) '/DATA/']);
                                    [F_e,Fdata,Fval_e,Fval,Ftest_e,Ftest,net] = estimationProgram(cell2mat(subjects(i)),cell2mat(combination(j)),classifier(k),'Order',order);
                                    save([path 'EMG' cell2mat(combination(j)) '/DATA/XF_' cell2mat(combination(j)) '_' cell2mat(subjects(i)) '_' order '_' cell2mat(classifier(k)) '_Estimated.mat'],'F_e','Fdata','Fval_e','Fval','Ftest_e','Ftest');
                                end
                            case {'nn','rn'}
                                for m=1:length(nodes)
                                    mkdir([path 'EMG' cell2mat(combination(j)) '/DATA/run' num2str(l) '/']);
                                    mkdir([path 'EMG' cell2mat(combination(j)) '/RMSE/run' num2str(l) '/']);
                                    [F_e,Fdata,Fval_e,Fval,Ftest_e,Ftest,net] = estimationProgram(cell2mat(subjects(i)),cell2mat(combination(j)), classifier(k),'Order',order, 'HiddenNodes', nodes(m));
                                    save([path 'EMG' cell2mat(combination(j)) '/DATA/run' num2str(l) '/XF_' cell2mat(combination(j)) '_' cell2mat(subjects(i)) '_' order '_' cell2mat(classifier(k)) '_' num2str(nodes(m)) '_nodes_Estimated.mat'],'F_e','Fdata','Fval_e','Fval','Ftest_e','Ftest','net');
                                end
                        end
                end
            end
        end
    end
else
    for l=1:run
        for i=1:length(subjects)
        	for j=1:length(features)
                disp(['Running estimation on subject ' upper(cell2mat(subjects(i))) ' with feature: ' upper(cell2mat(features(j)))])
                for k=1:length(classifier)
                    switch char(classifier(k))
                        case {'lf','qf'},
                            if l==1
                                [F_e,Fdata,Fval_e,Fval,Ftest_e,Ftest,net] = estimationProgram(cell2mat(subjects(i)),cell2mat(features(j)),classifier(k),'Order',order);
                                save([path 'EMG' cell2mat(features(j)) '/DATA/XF_' cell2mat(features(j)) '_' cell2mat(subjects(i)) '_' order '_' cell2mat(classifier(k)) '_Estimated.mat'],'F_e','Fdata','Fval_e','Fval','Ftest_e','Ftest');
                            end
                        case {'nn','rn'},
                            for m=1:length(nodes)                   
                                [F_e,Fdata,Fval_e,Fval,Ftest_e,Ftest,net] = estimationProgram(cell2mat(subjects(i)),cell2mat(features(j)), classifier(k),'Order',order, 'HiddenNodes', nodes(m));
                                save([path 'EMG' cell2mat(features(j)) '/DATA/run' num2str(l) '/XF_' cell2mat(features(j)) '_' cell2mat(subjects(i)) '_' order '_' cell2mat(classifier(k)) '_' num2str(nodes(m)) '_nodes_Estimated.mat'],'F_e','Fdata','Fval_e','Fval','Ftest_e','Ftest','net');
                            end
                    end
                end
            end
        end
    end
end

clear l i j k m F_e Fdata Fval_e Fval Ftest_e Ftest net path