function retur = calculatePerformance_angleSpecific(subject, order,angleNo, feature, path, type, varargin)
global smooth_const Flowpass Klowpass freq post_filter_lp use_smooth_const;

use_neural = 0;

for k=1:size(varargin,2) 
     switch char(varargin{k})
         case 'HiddenNodes',
             HiddenNodes = varargin{k+1};
             use_neural = 1;
         otherwise,
             %do nothing;
     end
end
 
% Load eiter lf/qf or nn/rn data.
if use_neural == 1
    load ([path 'XF_' feature '_' subject '_' order '_' type '_' num2str(HiddenNodes) '_nodes_Estimated.mat']);   
else
    load ([path 'XF_' feature '_' subject '_' order '_' type '_Estimated.mat']);
end

b_train = Fdata(angleNo,:);%#ok<COLND>
b_val = Fval(angleNo,:);%#ok<COLND>
b_test = Ftest(angleNo,:);%#ok<COLND>
a_train = F_e(angleNo,:); %#ok<COLND>
a_val = Fval_e(angleNo,:);%#ok<COLND> 
a_test = Ftest_e(angleNo,:); %#ok<COLND>

% Defines if we want to average with respect to the last smooth_const
% samples. Value is set in the init.m file.
if use_smooth_const == 1
    a_train = smoothing(a_train,smooth_const);
    a_val = smoothing(a_val,smooth_const);
    a_test = smoothing(a_test,smooth_const);
end

% Correlation coefficient
R=corrcoef(a_train,b_train);
T=corrcoef(a_val,b_val);
Y=corrcoef(a_test,b_test);

retur.correlation_train = R(1,2);
retur.correlation_val = T(1,2);
retur.correlation_test = Y(1,2);

% Cosinus Similarity Transform
retur.cst_train = dot(a_train,b_train)/(norm(a_train)*norm(b_train));
retur.cst_val = dot(a_val,b_val)/(norm(a_val)*norm(b_val));
retur.cst_test = dot(a_test,b_test)/(norm(a_test)*norm(b_test));

% RMSE
e_train = b_train - a_train;
e_val = b_val - a_val;
e_test = b_test - a_test;
retur.rmse_train = sqrt(mse(e_train*180/pi));
retur.rmse_val = sqrt(mse(e_val*180/pi));
retur.rmse_test = sqrt(mse(e_test*180/pi));

% %Coherence
% tmin=1;
% tmax=200;
% fs=20;
% t = tmin:1/fs:tmax;
% x = a_val(angleNo,tmin*fs:tmax*fs);
% y = b_val(angleNo,tmin*fs:tmax*fs);
% z = Fval_e(angleNo,tmin*fs:tmax*fs);
% 
% figure(1)
% plot(t,x*180/pi)
% hold on
% plot(t,y*180/pi,'r')
% hold off
% 
% [Cxy,F] = mscohere(x,y,[],[],50,4);
% 
% z = lpfilter(z,Klowpass,Flowpass);%#ok<COLND>
% z = smoothing(z,smooth_const);
% 
% figure(2)
% plot(t,z*180/pi)
% hold on
% plot(t,y*180/pi,'r')
% hold off
% 
% [xCxy,xF] = mscohere(z,y,[],[],50,4);
% 
% 
% frw= a(1:3)
% retur.coherence_value_train = Cxy;
% retur.coherence_freq_train = F;
return;