function Y = hpfilter(X,K,F)
%% High-pass filter
% INPUT OPTIONS
% X:    signal array to filter.
% K:    Gain.
% F:    Cut-off frequency.
% High-pass filter to get average to zero.
% This function uses the filtfilt() internal command of matlab.
% 
% Per Ferdinand Bach, perferdi@stud.ntnu.no
% $Revision: 1.0 $Date: 2009/01/19 12:00:00 $

%Tuning variables
%K = 0.57;  %Gain.
%F = 0.25;  %Frequency.

w = 2*pi*F; % omega -> rad/s
s = tf('s'); % Create transfer function.
H = (K*s) / (s + w); % Filter structure.
[num,den] = tfdata(H); %we want the numerater and denumerater separated.
num = num{1};
den = den{1};

for a=1:size(X,1)
    eval('Y(a,:) = filtfilt(den,num,X(a,:));');
    Y(a) = (Y(a));
end
